/* 

    umesh2dgui, a GUI for umesh2d grid generator 

    Copyright (C) 2003 Gabriele Dini Ciacci
  
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/

#include "MyGL.h"


void MyGL::draw() {
  if(!valid()) {
    /*projection
     *viewport
     *  w() e h() sono le dimensioni della finestra
     *  valid() is turned on after FLTK draw() returns
     */
    ortho();
  }
  /* draw */
  MyInit();
  drawgeometry();
  //  swap_buffers();
}

int MyGL::handle(int event) {
/* don't call any OpenGL draw function from inside handle() */
/* we handle no events for now */
  switch(event) {
    /*  case fltk::PUSH:

    return 1;
  case fltk::DRAG:

    return 1;

  case fltk::RELEASE:

    return 1;
    */
    /* those are events i want to to handle */
  default:
    /* the base class here handle the others */
    return fltk::GlWindow::handle(event);
  }
}

void MyGL::drawprimitive(Primitive *curprim) {
  switch(curprim->type) {
    case PR_LINE:
#ifdef DEBUGGING
      fprintf(stdout, "before glBegin()\n");
      fprintf(stdout, "%.2f, %.2f\n", ((Line *)curprim)->x1, ((Line *)curprim)->y1);
      fprintf(stdout, "%.2f, %.2f\n", ((Line *)curprim)->x2, ((Line *)curprim)->y2);
#endif
      glBegin(GL_LINES);
      glVertex2f(((Line *)curprim)->x1,((Line *)curprim)->y1);
      glVertex2f(((Line *)curprim)->x2,((Line *)curprim)->y2);
      glEnd();
      glFlush();
#ifdef DEBUGGING
      fprintf(stdout, "after glEnd()\n");
#endif
      break;
    case PR_CIRCLE:
      glBegin(GL_LINE_LOOP);
      for(int i = 0; i < 200; i++){
	glVertex2f(((Circle *)curprim)->centerx + ((Circle *)curprim)->radius * cos(2*3.14*i/200), \
                   ((Circle *)curprim)->centery + ((Circle *)curprim)->radius * sin(2*3.14*i/200));
      }
      glEnd();
      glFlush();
      break;
    case PR_ELLIPSE:
      glBegin(GL_LINE_LOOP);
      for(int i = 0; i < 200; i++){
	glVertex2f(((Ellipse *)curprim)->centerx + ((Ellipse *)curprim)->semix * cos(2*3.14*i/200), \
                   ((Ellipse *)curprim)->centery + ((Ellipse *)curprim)->semiy * sin(2*3.14*i/200));
      }
      glEnd();
      glFlush();
      break;
    case PR_DATA:
      fprintf(stdout, "Data draw not supported");
      break;
    default:
      fprintf(stderr, "PRINTING: Unknown primitive type\n");
    }
}

void MyGL::drawgeometry() {
  //  make_current();
  fprintf(stdout, "inside drawgeometry\n");
  glClear(GL_COLOR_BUFFER_BIT);
  Primitive *currentprimitive;
  currentprimitive = firstprimitive;
  for(int i = 1; i <= nprim; i++) {
    drawprimitive(currentprimitive);
    if(currentprimitive->nextprimitive != NULL) {
      currentprimitive = currentprimitive->nextprimitive;
    }
    else if (currentprimitive->nextprimitive == NULL && i != nprim) {
      fprintf(stderr, "drawgeometry: WTF!? How we are here?, nprim say we still have" \
                      "primitive to draw but currentprimitive->nextprimitive" \
                      "pointer is NULL. nprim MISMATCH!!!!\n");
    }
  }
}

void MyGL::MyInit(){
  glClearColor(0.0, 0.0, 0.0, 0.0); //black
  glClear(GL_COLOR_BUFFER_BIT); // the background
  glColor3f(1.0, 1.0, 1.0);  //white
  glLineWidth((GLfloat)1); // 1 width for lines
}

void MyGL::setprim(Primitive *prim, int n) {
  firstprimitive = prim;
  nprim = n;
}

